#include "stdafx.h"              // must 1st line
#include "direct.h"
#include "gsc.h"
#include "gscchar.h"
#include "gscDoc.h"
#include "gscView.h"
#include "math.h"
#include "MainFrm.h"

#define  nn   60000
double aa[nn],dd[nn];                      // always epoch + proper motion
double rc,dc,a_c,d_c,up_a,dn_a,up_d,dn_d;  // always 2000.0 a_c,d_c(arc)
double oepoch,epoch;                       // input,out_put catalog's epoch
double alph_a,delt_a;                      // always epoch, h,d center
double hs,cx,cy,w_de,xlimag,hs2,pi,cosdc,xm_min,xm_max;
short  ee[nn],ex[nn],ey[nn];               // mag,x,y
int    u3index[240][360],no[nn],n;         // n all select star
FILE   *fp,*fp0,*fp1;                      // fp1 not use, for tmp
char   c1[14],c2[14];                      // normal format of alpha delta

double v_oepoch,v_nepoch,v_field,v_alpha,v_delta,v_limag,v_ltime;
char   al[14],aphi[14];                    // lamda, phi of station
char   disk[30]={"d:/ucac3/"};


struct tm *t;

double tohd(char *a);
void gscmap();
void g89(double mag,int istar,short ix,short iy,int j);
void astprs(double ra1,double dec1,double ep1,double *ra2,double *dec2,double ep2);
void standc(double rc,double dc,double ra,double de,double *xi,double *xn);
void xytoad(double x[2][3],double a[2][3]);
void astand(double rc,double dc,double xi,double xn,double *ra,double *de);
void toms2(double aa,char cc[],int k);
void dpgtext(int ix,int iy,double d);
void pgnewpage();
void cat_u3(int i);
void togif();
int  i_star(double x, double y, short *ix, short *iy);
int  getstar(int ix,int iy);
int  inpic(int ix,int iy);

// CGscView construction/destruction
CBitmap    Bitmap;
BITMAP     bm;
CDC        MemDC,*tDC;
CPen       Pen;

short map[511][511];                       //  511*511 map
char *buf;          // bmp body
int        idc=0;

const int  lw=980;
const int  lh=604;
const int  lw1=38;
const int  lh1=50;
int        lw2;

unsigned char bc;   // for bmp_map
int tc,tcolor[16]={ 0x000000, 0xffffff, 0x0000ff, 0x00ff00,
                    0xff0000, 0xffff00, 0xff00ff, 0x00ffff,
                    0x0080ff, 0x00ff80, 0x80ff00, 0xff8000,
                    0xff0080, 0x8000ff, 0xffebe1, 0x3fff3f };
char plate[256][4];            // read from uc3.bmp & always use it

char f1[30];                   // gif name
int  gifno=0;                  // gif name ++
char lab[70],dis[70],dis0[50],dis2[50],sc[5];
int  sx[4]={540,540,0,0}, sy[4]={535,540,540,535};
int  num;                      // lfmouse, select star++
int  k31;                      // as num, draw pic using
int  fi;                       // field size print

int  newgsc=-2,oldgsc=0;       // pic control is newgsc
int  it;                       // bmp  passwd

IMPLEMENT_DYNCREATE(CGscView, CScrollView)
BEGIN_MESSAGE_MAP(CGscView, CScrollView)
        //{{AFX_MSG_MAP(CGscView)
        ON_WM_LBUTTONDOWN()
        ON_WM_RBUTTONDOWN()
        ON_WM_MOUSEMOVE()
        ON_WM_MOUSEWHEEL()

        ON_WM_KEYDOWN()
        ON_COMMAND(ID_DLG, OnDlg)
        ON_WM_TIMER()
END_MESSAGE_MAP()

CGscView::CGscView()                 // start program routine, inintial ....
{
  int j=0;
  unsigned char a[10]={0,0,0,0,0,0,0xb7,0x94,0x73,0xb7};  // passwd of pic
  disk[0]=_getdrive()+64; goto l11;     // find disk auto
l10:
  j++; if(j>8)exit(0);
  disk[0]=(char)(j+66);
l11:
  strcpy(dis,disk); strcat(dis,"uc3.bmp");   // 256, plate
  fp=fopen(dis,"rb");  if(fp==0)goto l10;
  fseek(fp,54,0); fread(plate,1,1024,fp); fclose(fp);

  strcpy(dis,disk); strcat(dis,"uc33.bmp");   // 16m pic
  fp=fopen(dis,"rb");
  fseek(fp,5050*256,0); fread(lab,1,10,fp); fclose(fp);

  it=0; for(j=0;j<10;j++)if(a[j]!=(unsigned char)lab[j])it=1; // check passwd

  HBITMAP hBitmap=(HBITMAP)LoadImage(0,_T(dis),IMAGE_BITMAP,
    0,0,LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE);
  Bitmap.Attach(hBitmap);                                     // display high

  strcpy(dis,disk); strcat(dis,"u3index2.unf");
  fp=fopen(dis,"rb");  fread(u3index,360*240,4,fp); fclose(fp);

  strcpy(dis,disk); strcat(dis,"langitud.dat");
  fp=fopen(dis,"r");
  if(fp!=0){
    fgets(dis,70,fp);
    for(j=0;j<12;j++)if(dis[j]>'-')al[j]=dis[j];else break; al[j]=0;
    fgets(dis,70,fp);
    for(j=0;j<12;j++)if(dis[j]>'-')aphi[j]=dis[j];else break; aphi[j]=0;
    fgets(dis,70,fp);  sscanf(dis,"%d",&j);
    fclose(fp);
    Dlg.m_lamda.Format("%s\0",al);
    Dlg.m_phi.Format("%s\0",aphi);
    Dlg.m_ltime.Format("%d\0",j);
  }

  pi=4.*atan(1.); cx=pi/12.; cy=pi/180.;

//  fp1=fopen("u3.tmp","w");             // while need write down to debug,

}

void CGscView::OnDlg()
{
    char aa[20];
    double x,xa,xd;
L10:
    if(Dlg.DoModal()==IDOK){
      strncpy(c1,Dlg.m_alpha,14);
      strncpy(c2,Dlg.m_delta,14);
      strncpy(aa,Dlg.m_oepoch,12);     sscanf(aa,"%lf",&v_oepoch);
      strncpy(aa,Dlg.m_nepoch,12);     sscanf(aa,"%lf",&v_nepoch);
      if(c1[0]==0){ strcpy(aa,Dlg.m_alpha1);  strcpy(c1,&aa[7]); }
      if(c2[0]==0){ strcpy(aa,Dlg.m_delta1);  strcpy(c2,&aa[7]); }
      x=tohd(c1); if(x>=0.   && x< 24.)v_alpha=x; else goto L10;
      x=tohd(c2); if(x>=-90. && x<=90.)v_delta=x; else goto L10;
      strncpy(aa,Dlg.m_field,12);      sscanf(aa,"%lf",&v_field);
      strncpy(aa,Dlg.m_limag,12);      sscanf(aa,"%lf",&v_limag);
      strncpy(al,Dlg.m_lamda,12);
      strncpy(aphi,Dlg.m_phi,12);
      strncpy(aa,Dlg.m_ltime,12);      sscanf(aa,"%lf",&v_ltime);
      if(v_field< 10.){ v_field= 10.;  Dlg.m_field.Format("10.\0"); }
      if(v_field>240.){ v_field=240.;  Dlg.m_field.Format("240.\0"); }
      if(v_limag<10.){ v_limag=10.;    Dlg.m_limag.Format("10.\0");}
      if(v_limag>18.){ v_limag=18.;    Dlg.m_limag.Format("18.\0"); }
      Dlg.m_alpha.Format("");
      Dlg.m_delta.Format("");
      toms2(v_alpha,c1,1);
      toms2(v_delta,c2,0);
      Dlg.m_alpha1.Format("ྭ   %s\0",&c1[1]);
      Dlg.m_delta1.Format("γ   %s\0",c2);
      if(newgsc==-2)newgsc=-1;
      if(newgsc== 0)newgsc= 1;
      if(it)newgsc=0;
    }
      rc=v_alpha;      dc=v_delta;
      oepoch=v_oepoch; epoch=v_nepoch;
      w_de=v_field;    xlimag=v_limag;
      if(oepoch<1950. || oepoch >2050.)oepoch=2000.;
      if(oepoch!=2000.){ astprs(rc,dc,oepoch,&xa,&xd,2000.); rc=xa; dc=xd; }

      pgnewpage();Invalidate();
}

void CGscView::OnDraw(CDC* pDC)
{
  CGscDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);

  if(newgsc==1){
    gscmap();
    newgsc=0;
    SetTimer(1,1000,0);
  }

  if(newgsc==-1){

    strcpy(dis,disk); strcat(dis,"uc3.bmp");
    HBITMAP hBitmap=(HBITMAP)LoadImage(0,_T(dis),IMAGE_BITMAP,
       0,0,LR_CREATEDIBSECTION|LR_DEFAULTSIZE|LR_LOADFROMFILE);
    Bitmap.Attach(hBitmap);

    pgnewpage(); Invalidate();
    newgsc=1;
    SetTimer(1,1000,0);
  }

    Bitmap.GetBitmap(&bm);
    buf=(char*)bm.bmBits;
    MemDC.CreateCompatibleDC(pDC);
    CBitmap* pOldBitmap = MemDC.SelectObject(&Bitmap);
    tDC=pDC;

    pDC->BitBlt(0, 0, bm.bmWidth, bm.bmHeight, &MemDC, 0, 0, SRCCOPY);
    MemDC.SelectObject(pOldBitmap);

    idc=1;                          /* release tdc */
    if(oldgsc==-1 && newgsc==1){
      pgnewpage(); Invalidate();
    }
    oldgsc=newgsc;
}

void pgsci();
void pgsci(int i)
{
  bc=i;
  tc=tcolor[i];
  Pen.DeleteObject();
  Pen.CreatePen(PS_SOLID,1,tc);
}
int cal2();
int cal2(int x, int y)
{
  int k=0;
  if(x<0 || x>=lw)return(k);
  if(y<0 || y>=lh)return(k);
  k=(lh-1-y)*lw+x;
  return(k);
}
void pgpoint();
void pgpoint(int ix, int iy, char z)
{
  int i,j,k,m;
  m=(int)z;
  for(i=-3;i<=3;i++){
    k=f08[m][i+3];
    if(k==0)continue;
    for(j=-4;j<=3;j++){
      if((k%2)!=0){
        *(buf+cal2(ix+i,iy-j))=bc;
        if(idc)tDC->SetPixelV(ix+i,iy-j,tc);
      }
      k=k/2;
    }
  }
}
void pgline();
void pgline(int x[], int y[], int n)
{
  int i,j,id,ix,ix1,ixx,iy,iy1,iyy;
  double xx,yy,dx,dy;
  if(n<2)return;
  if(idc){
    tDC->SelectObject(&Pen);
    tDC->MoveTo(x[0],y[0]);
    for(i=1;i<n;i++)tDC->LineTo(x[i],y[i]);
  }
  ixx=iyy=0;
  for(i=1;i<n;i++){
    ix1=x[i-1]; iy1=y[i-1];
    ix=ix1-x[i]; iy=iy1-y[i];
    id=abs(ix); if(abs(iy)>id)id=abs(iy);
    if(id!=0){
      dx=(double)ix/id;
      dy=(double)iy/id;
      xx=(double)ix1; yy=(double)iy1;
      for(j=0;j<=id;j++){
        ix=(int)xx;   iy=(int)yy;
        if(ix!=ixx || iy!=iyy){
          ixx=ix; iyy=iy;
          *(buf+cal2(ix,iy))=bc;
        }
        xx-=dx; yy-=dy;
      }
    }
  }
}
void pgchar();
void pgchar(int ix, int iy, int n, int ik)
{
//   ik=1,-1; 2,-2
  int i,j,k,jx,jy,m;
  if(ik<0){
    m=n&0xff;    if(m>140)return;
    for(i=0;i<7;i++){
      k=f08[m][i];
      if(k==0)continue;
      for(j=-7;j<=0;j++){
        if((k%2)!=0){
          if(ik==-1){ jx=ix+i; jy=iy-j; }
          if(ik==-2){ jx=ix-j; jy=iy-i; }
          *(buf+cal2(jx,jy))=bc;
          if(idc)tDC->SetPixelV(jx,jy,tc);
        }
        k=k/2;
      }
    }
  }
  if(ik>0){
    if(n<=32||n>126)return;
    m=n-33;
    for(i=0;i<16;i++){
      k=f16[m][i];
      if(k==0)continue;
      for(j=-7;j<=0;j++){
        if((k%2)!=0){
          if(ik==1){ jx=ix-j; jy=iy+i; }
          if(ik==2){ jx=ix+i; jy=iy+j; }
          *(buf+cal2(jx,jy))=bc;
          if(idc)tDC->SetPixelV(jx,jy,tc);
        }
        k=k/2;
      }
    }
  }
}
void pgtext();
void pgtext(int x, int y, char *c, int k)
{
  int i,ix,iy;
  ix=x; iy=y;
  for(i=0;i<(int)strlen(c);i++){
    pgchar(ix,iy,c[i],k);
    if(abs(k)==1)ix=ix+8+k;
    if(abs(k)==2)iy=iy-8-k/2;
  }
}

void pgnewpage()
{
  int i;
  idc=0;
  for(i=0;i<lw*lh;i++)*(buf+i)=14;
}
void whan();
void whan(int ix, int iy, int ic, int id)
{
  int i,j,k,jx,jy;
  short a[16];
  for(i=0;i<16;i++)a[i]=0;
  k=ic%100;        if(k>94 || k==0 )return;
  k+=(ic/100-1)*94;  if(k<0||k>8178)return;
  k--;
  strcpy(dis,disk);    strcat(dis,"han.162");
  fp=fopen(dis,"rb");  fseek(fp,k*32,0);  fread(a,2,16,fp);  fclose (fp);
  for(i=0;i<16;i++){
    k=a[i]&0xffff;
    if(id==1){
      jy=iy+i; jx=ix+16;
      for(j=0;j<16;j++,k/=2,jx--)if(k%2==1){
        *(buf+cal2(jx,jy))=bc;
        if(idc)tDC->SetPixelV(jx,jy,tc);
      }
    }
    if(id==2){
      jy=iy+0; jx=ix+i;
      for(j=0;j<16;j++,k/=2,jy++)if(k%2==1){
        *(buf+cal2(jx,jy))=bc;
        if(idc)tDC->SetPixelV(jx,jy,tc);
      }
    }
  }
}
void h16();
void h16(int ix, int iy, int a[], int n, int gap, int id)
{
  int i,ix0=ix,iy0=iy-16;
  if(id==1)for(i=0;i<n;i++,ix0+=16+gap)whan(ix0,iy,a[i],id);
  else     for(i=0;i<n;i++,iy0-=16+gap)whan(ix,iy0,a[i],id);
}

CGscView::~CGscView(){}
BOOL CGscView::PreCreateWindow(CREATESTRUCT& cs)
{
  return CScrollView::PreCreateWindow(cs);
}

void CGscView::OnInitialUpdate()
{
  CSize sizeTotal;
  sizeTotal.cx = lw;
  sizeTotal.cy = lh;
  SetScrollSizes(MM_TEXT, sizeTotal);
  CScrollView::OnInitialUpdate();
}
                                   // left button************ pick star
void CGscView::OnLButtonDown(UINT nFlags, CPoint point)
{
  CDC *pDC=GetDC();
  tDC=pDC;
  double r,rr,xmag;
  int i,m,mx,my;
  char cc;

  mx=point.x-lw1; my=point.y-lh1;
/*
  for(i=0;i<16;i++){                 // display 16 color
    pgsci(i);  sprintf(dis,"%d",i);
    pgtext(570+i*20,20,dis,1);
  }  pgsci(0);
*/
    r=10000.;
    for(i=0;i<n;i++){
      rr=(ex[i]-mx)*(ex[i]-mx)+(ey[i]-my)*(ey[i]-my);
      if(rr<r){ m=i; r=rr; }
    }
    if(r>99.)return;
    mx=ex[m]; my=ey[m];
    num++; sprintf(sc,"%3d",num);
    pgsci(4);    pgtext(mx+lw1-6,my+lh1-12,sc,-1);
    toms2(aa[m],c1,1);  toms2(dd[m],c2,0);
    xmag=(double)ee[m]*0.001; if(xmag<0.)xmag=-xmag;
    cc='S'; if(ee[m]<0)cc='G';
    sprintf(dis,"%3d) %s %s (%6.1lf) %010d %c %5.2lf",
                  num,c1,c2,epoch,no[m],cc,xmag);
    for(i=41;i<44;i++)dis[i]=dis[i+1]; dis[i]='-';

    if(k31<31){ k31++; pgsci(0); pgtext(550,k31*18,dis,-1); }

    pgsci(14); pgtext(40,575,dis0,-1);
    sprintf(dis0,"%2d) %s %s %c %5.2lf",num,c1,c2,cc,xmag);
    pgsci(13); pgtext(40,575,dis0,-1);

  CScrollView::OnLButtonDown(nFlags, point);
}


BOOL CGscView::OnMouseWheel(UINT nFlags,short zDelta,CPoint pt)
{

//  fprintf(fp1,"%d %d\n",nFlags,zDelta); fflush(fp1);
    double r;
    int k;
    if(zDelta==120){r=w_de*1.05; k=(int)(r+.5); r=(double)k; if(r==w_de)r+=1.;}
            else   {r=w_de/1.05; k=(int)(r+.5); r=(double)k; if(r==w_de)r-=1.;}
    w_de=r;
    newgsc=1;  pgnewpage(); Invalidate();

    return (0);
    CScrollView::OnMouseWheel(nFlags,zDelta,pt);
}

int getstar(int ix,int iy)
{
  double xi,xn,xa,xd;
  int mx,my;
  mx=ix-lw1;     my=iy-lh1;
  if(mx<0 || mx>510 || my<0 || my>510)return(0);
  xi=(255.-mx)/hs2;
  xn=(255.-my)/hs2;
  astand(alph_a*cx,delt_a*cy,xi,xn,&xa,&xd);
  toms2(xa/cx,c1,1); toms2(xd/cy,c2,0);
  return(1);
}

void CGscView::OnMouseMove(UINT nFlags, CPoint point)
{
    if(newgsc<0)return;
    if(getstar(point.x,point.y)==0)return;

    CMainFrame *pFrame=(CMainFrame *)AfxGetApp()->m_pMainWnd;
    CStatusBar *pSt=&pFrame->m_wndStatusBar;
    if(pSt){ pSt->SetPaneText(0,c1); pSt->SetPaneText(1,c2); }
    CScrollView::OnMouseMove(nFlags, point);
}

void CGscView::OnRButtonDown(UINT nFlags, CPoint point)
{                                      // right button********* new center
  double xi,xn,xa,xd;
  int i,m,x,y,r,rr;

  x=point.x-lw1; y=point.y-lh1;
    r=10000;
    for(i=0;i<n;i++){
      rr=(ex[i]-x)*(ex[i]-x)+(ey[i]-y)*(ey[i]-y);
      if(rr<r){ m=i; r=rr; }
    }
/*
    if(r<99){
      standc(alph_a*cx,delt_a*cy,aa[m]*cx,dd[m]*cy,&xi,&xn);
      xa=hs2*(hs-xi);
      xd=hs2*(hs-xn);
    } else { xa=x; xd=y; }
    xi=hs-xa/hs2;    xn=hs-xd/hs2;
    astand(a_c,d_c,xi,xn,&xa,&xd);
    rc=xa/cx; dc=xd/cy;
*/
        if(r>99){
          xi=hs-x/hs2;    xn=hs-y/hs2;
      astand(a_c,d_c,xi,xn,&xa,&xd);
      rc=xa/cx; dc=xd/cy;
    } else {
      astprs(aa[m],dd[m],epoch,&rc,&dc,2000.);
    }
/*
      fp1=fopen("uc33.dat","w");
      fprintf(fp1,"alph_a,delt_a: %lf %lf\n",alph_a,delt_a);
      fprintf(fp1,"aa[m],dd[m]:   %lf %lf\n",aa[m],dd[m]);
      fprintf(fp1,"x,y,xi,xn:     %lf %lf %lf %lf\n",x,y,xi,xn);
      fprintf(fp1,"xa,xd:         %lf %lf\n",rc,dc);
      astprs(aa[m],dd[m],epoch,&xa,&xd,2000.);
      fprintf(fp1,"from star:         %lf %lf\n",xa,xd);
      fclose(fp1);
*/
  newgsc=1;  pgnewpage(); Invalidate();
  CScrollView::OnRButtonDown(nFlags, point);
}

void CGscView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
  unsigned char c,cc;
  int i,j,k;
  double xmag,xa,xd;
  double r;

  c=nChar;
  if(c=='c' || c=='C'){
    fp0=fopen("u3.cat","w");
    strcpy(dis,lab); sprintf(&dis[46],"m Field"); dis[53]=':';
    fprintf(fp0,"#center:%s\n#",lab);
    for(i=0;i<60;i++)fprintf(fp0,"-"); fprintf(fp0,"\n");
    for(i=0;i<n;i++){
      toms2(aa[i],c1,1);  toms2(dd[i],c2,0);
      xmag=ee[i]*0.001; if(xmag<0.)xmag=-xmag;
      cc='s'; if(ee[i]<0)cc='g';
      sprintf(dis,"%5d%s %s (%6.1lf) %010d %c %6.3lf",
                     i+1,c1,c2,epoch,no[i],cc,xmag);
      for(j=41;j<44;j++)dis[j]=dis[j+1]; dis[j]='-';
      fprintf(fp0,"%s\n",dis);
    }
    fclose(fp0);
    pgsci(14);    pgtext(660,14,dis2,1);
    sprintf(dis2,"u3.cat produced!");
    pgsci(12);    pgtext(660,14,dis2,1);
    goto l10;
  }

  if(c=='g' || c=='G'){            // produed GIF file
    sprintf(f1,"u3%02d.gif",++gifno); if(gifno==99)gifno--;
    if(num<=1)lw2=588;
    togif();  lw2=lw;
    pgsci(14);    pgtext(660,14,dis2,1);
    sprintf(dis2,"%s produced!",f1);
    pgsci(13);    pgtext(660,14,dis2,1);
    goto l10;
  }
  if(c=='9'){r=w_de*1.05;k=(int)(r+.5);r=(double)k;if(r==w_de)r+=1.;w_de=r; goto l5;}
  if(c=='3'){r=w_de/1.05;k=(int)(r+.5);r=(double)k;if(r==w_de)r-=1.;w_de=r; goto l5;}
  xd=w_de/60.; xa=w_de/60./15./cosdc;
  if(c=='8' || c==38){ dc-=xd/50.;  goto l5; }
  if(c=='2' || c==40){ dc+=xd/50.;  goto l5; }
  if(c=='4' || c==37){ rc-=xa/50.;  goto l5; }
  if(c=='6' || c==39){ rc+=xa/50.;  goto l5; }
  return;
l5:
  newgsc=1;  pgnewpage();
//   fprintf(fp1,"%d",c); fflush(fp1);
l10:
  Invalidate();                   // force to display
  CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void dpgtext(int ix, int iy, double d)           // out a var on crt
{
  char a[15];
  sprintf(a,"%lf",d);
  pgtext(ix,iy,a,-1);
}

void gscmap()
{
  double hw_de,hw_al,xmag,xa,xd;
  double  x,y,z;
  int i,j,k,istar,k1,k2;
  int nx[5],ny[5];

  while(rc>24.)rc-=24.;     while(rc<0.)rc+=24.;
  if(dc>89.99)dc=89.99;  if(dc<-89.99)dc=-89.99;

      if(epoch<1950. || epoch >2050.)epoch=2000.;
      astprs(rc,dc,2000.,&xa,&xd,epoch);
      alph_a=xa; delt_a=xd;

  if(w_de<10.)w_de=10.;  if(w_de>240.)w_de=240.;  //field:  10~~240'
  fi=(int)(w_de*0.25+0.5); sprintf(sc,"%3d'",fi);
  sx[2]=sx[3]=(int)(540.-fi/w_de*511.);

  hw_de=w_de/120.;
  up_d=dc+hw_de;   if(up_d> 90.0)up_d= 90.;
  dn_d=dc-hw_de;   if(dn_d<-90.0)dn_d=-90.;

  x=cos(up_d*cy);   y=cos(dn_d*cy);  z=x; if(z>y)z=y;
  hw_al=hw_de/z/15.;  if(hw_al>12.)hw_al=12.;
  up_a=rc+hw_al;      if(up_a>=24.)up_a-=24.;
  dn_a=rc-hw_al;      if(dn_a<  0.)dn_a+=24.;

  hs=hw_de*cy;   hs2=255./hs;
  a_c=rc*cx;     d_c=dc*cy;
  cosdc=cos(d_c); if(cosdc<.05)cosdc=.05;

  k1=(int)((dn_d+90.)*2.+1.);  k2=(int)((up_d+90.)*2.+0.9999);
  n=0;  for(i=k1;i<=k2;i++)cat_u3(i);

  sprintf(dis,"u3_star:%5d\n",n);
  pgtext(620,580,dis,1);

  if(n==0){
    pgsci(14);    pgtext(660,14,dis2,1);
    sprintf(dis2,"No star in area!");
    pgsci(13);    pgtext(660,14,dis2,1);
  }

  xm_max=0.; xm_min=99.;
  for(i=0;i<511;i++)for(j=0;j<511;j++)map[i][j]=0; // project star
  k=(int)(35-20*w_de/120.); if(k>33)k=33; if(k<15)k=15; j=(33-k)/2;
  for(i=0;i<n;i++){            // if star, istar=-1;  galaxy, istar=1
    xmag=ee[i]*0.001; istar=-1; if(xmag<0.){ xmag=-xmag; istar=1; }
    g89(xmag,istar,ex[i],ey[i],j);
  }
// putmap
  for(i=0;i<511;i++)for(j=0;j<511;j++)
    *(buf+cal2(i+lw1,j+lh1))=(char)(255-map[j][i]);
  pgsci(2);
// cros
  for(i=252;i<259;i++)
    *(buf+cal2(i+lw1,i+lh1))=*(buf+cal2(i+lw1,510-i+lh1))=2;
// field scale
  pgline(sx,sy,4);
  sprintf(dis,"%3d'",fi);
  pgtext(470,520,dis,1);
  pgsci(0);
// frame
  nx[4]=nx[0]=nx[1]=lw1-1;
  nx[2]=nx[3]=nx[0]+511;

  ny[4]=ny[0]=ny[3]=lh1-1;
  ny[1]=ny[2]=ny[0]+511;
  pgline(nx,ny,5);

// draw map
  int q13[10]={ 1964,3013,308,3647,309,1964,4619,308,2211,309};
  pgsci(0);
  h16(470,580,q13,5,1,1);      // R.A.
  h16(8,150,&q13[5],5,1,2);    // Decl.

  pgtext(360,580,"R.A. South",1);
  pgtext(8,400,"(UCAC3)      Decl. East",2);

  time_t it=time(NULL);
  t=localtime(&it);  strcpy(dis,asctime(t)); dis[strlen(dis)-1]=0;
  pgsci(6); pgtext(792,592,dis,-1);

  toms2(alph_a,c1,1); toms2(delt_a,c2,0);
  sprintf(lab,"%s %s (%6.1f) %4.1lf~~%4.1lf%7d'",c1,c2,epoch,xm_min,xm_max,(int)w_de);
  pgsci(4); pgtext(55,20,lab,1);  pgtext(452,16,"m",-1);

  num=0;
  k31=1;
  lw2=lw;
}

double tohd(char a[])
{
  double x=0.;
  char b[14];
  int i,j=0,k=1;
  for(i=0;i<14;i++)b[i]=32;  b[11]=0;
  for(i=0;i<14;i++){
    if(a[i]==0)break;
    b[i]=a[i];
    if(b[i]=='-')k=-1;
    if(b[i]=='.')continue;
    if(b[i]<48 || b[i]>57)b[i]=32;
  }
  sscanf(b,"%d%d%lf",&i,&j,&x);
  x=(double)i+(double)j/60.+x/3600.;
  if(k<0)x=-x;
  return(x);
}

double  fjd(int iy,int im,int id)
{
  int i,j;
  i=(int)((im+9)*0.09);
  i=(int)((i+iy-1900)*1.75+0.01);
  j=(int)(30.56*im);
  j=(iy-1950)*367+id+j-i;
  return(2433338.5+j);
}

void CGscView::OnTimer(UINT nIDEvent)
{
    struct tm *t;
    char a[4],c,bt[11],st[14],time_angle[14],ag[14],ah[14],aj[15],diss[30];
    double d1,d2,ut,d,x1;
    double s0;
    int iy,im,id,i,j,k;
    char mon[12][4]={ "Jan","Feb","Mar","Apr","May","Jun",
                      "Jul","Aug","Sep","Oct","Nov","Dec"};
/* beijing time */
    time_t it=time(NULL);
    t=localtime(&it);
    strcpy(diss,asctime(t));
    for(i=0;i<8;i++)bt[i]=diss[i+11]; bt[8]='.'; bt[9]='0'; bt[10]=0;

    sscanf(&diss[8],"%d",&id);
    for(i=0;i<3;i++)a[i]=diss[i+4]; a[3]=0;
    for(i=0;i<12;i++)if(strcmp(mon[i],a)==0)break; im=i+1;
    sscanf(&diss[20],"%d",&iy);
    sscanf(&diss[11],"%2d%c%2d%c%2d",&i,&c,&j,&c,&k);
/* sereal time */
//  d1=fjd(2001,12,31);
    d1=2452274.5;
    d2=(6+37/60.+57.69/3600.)/24.;
//  x1=7+50/60.+18.344/3600.;
    x1=tohd(al);
//  v_ltime=8;
    ut=(i-v_ltime)+j/60.+k/3600.;

    d =fjd(iy,im,id);
//  jd
    sprintf(aj,"%14.5lf",d+ut/24.);
    d =(d-d1)*1.0027379093+d2;
    k =(int)d; d-=k;
    s0=d+(x1+ut*1.0027379093)/24.;
    if(s0<0.)s0+=1.; if(s0>=1.0)s0-=1.; s0*=24.;
    toms2(s0,st,1);  st[11]=0;

/* time angle */
    d=s0-alph_a; if(d>24.)d-=24.; if(d<0.)d+=24.;
    toms2(d,time_angle,1); time_angle[11]=0;
/* direct angle, latitude  */
    double s_delta,c_delta,s_hour,c_hour,sinh,cosh,sina,cosa,sphi,cphi;
    x1=tohd(aphi);
    if(x1>= 90.)x1= 89.9999;
    if(x1<=-90.)x1=-89.9999;
    x1*=cy;
    sphi=sin(x1);  cphi=cos(x1);
    s_delta=sin(delt_a*cy); c_delta=cos(delt_a*cy);
    s_hour=sin(d*cx);       c_hour=cos(d*cx);
    sinh=sphi*s_delta+cphi*c_delta*c_hour;
    cosh=sqrt(1.-sinh*sinh);
    sina=c_delta*s_hour/cosh;
    cosa=(sphi*c_delta*c_hour-cphi*s_delta)/cosh;
    d2=atan(sinh/cosh)/cy;
    d1=atan(sina/cosa)/cy;
    if(cosa<0.)d1+=180.;
    if(d1<0.)d1+=360.; if(d1>360.)d1-=360.;
    toms2(d1,ag,0);   ag[12]=0;
    toms2(d2,ah,0);   ah[11]=0;
/* write bar */
    CString str;
    CMainFrame *pFrame=(CMainFrame *)AfxGetApp()->m_pMainWnd;
    CStatusBar *pSt=&pFrame->m_wndStatusBar;
    if(pSt){
        str.Format("ʱ:%s",bt);         pSt->SetPaneText(2,str);
        str.Format("ʱ:%s",st);       pSt->SetPaneText(3,str);
        str.Format("ʱ:%s",time_angle); pSt->SetPaneText(4,str);
        str.Format("λ:%s",ag);       pSt->SetPaneText(5,str);
        str.Format("߶:%s",ah);         pSt->SetPaneText(6,str);
        str.Format(":%s",aj);       pSt->SetPaneText(7,str);
	}
    SetTimer(1,1000,NULL);
    CScrollView::OnTimer(nIDEvent);
}

void gauss(double *y,int m,double sigma)
{
  int i; double x;
  for(i=0;i<m;i++){
    x=i/sigma; x*=x; if(x>80.)return;
    y[i]=exp(-.5*x);
  }
}

void g89(double mag,int istar,short ix,short iy,int nj1)
{
  double y[33],x,xmag,w,high,sigma,rr,r;
  short  a[33][33];
  int    i,j,k,ii,jj,nj2,kr;

  nj2=32-nj1;  xmag=mag;  w=w_de;
  if(w>120.){ xmag+=4.; w/=4; }             // xmag changed
  for(i=0;i<33;i++)y[i]=0;
  high=16.; x=60./w+15.-xmag;
  if(w<=8.)x=60./w+(15.-xmag)*2.;
  if(istar==-1){                            // for star ***********
    if(xmag<6.)x=((6.-xmag)*0.3+1.)*x;
    sigma=.5+x*.25; gauss(y,33,sigma);
    rr=(sigma*0.5+0.5)/sqrt(40./w); if(rr<1.)rr=1.;
    for(j=nj1;j<17;j++){
      jj=(j-16); jj*=jj;
      for(i=nj1;i<17;i++){
        r=jj+(i-16)*(i-16);
        kr=(int)(sqrt(r)+0.5); r=y[kr]*high+0.5;
        if(j==16 || i==16)r*=rr;
        a[i][j]= a[i][32-j]= a[32-i][j]= a[32-i][32-j]=(short)r;
      }
    }
  } else {                                   // for galaxy ***********
    high=10.;
    sigma=1.+x*.2; gauss(y,33,sigma);
    for(j=nj1;j<17;j++){
      jj=(j-16); jj*=jj;
      for(i=nj1;i<=nj2;i++){
        r=jj+(i-16)*(i-16)+(i-16)*(16-j);
        kr=(int)(sqrt(r)+0.5); r=y[kr]*high;
        if(r>0.5 && r<1.)r=1.; if(r>9.)r=9.;
        a[32-i][j]= a[i][32-j]=(short)r;
      }
    }
  }
  if(mag>xm_max)xm_max=mag; if(mag<xm_min)xm_min=mag;

  for(j=nj1;j<=nj2;j++){
    jj=iy-16+j; if(jj<0 || jj>510)continue;
    for(k=nj1;k<=nj2;k++){
      ii=ix-16+k; if(ii>=0 && ii <511)map[jj][ii]+=a[k][j];
    }
  }
}

int i_star(double ra,double dc,short *ix,short *iy)
{
  double xa,xd,xi,xn;
  xa=ra*cx; xd=dc*cy;
  standc(a_c,d_c,xa,xd,&xi,&xn);
  *ix=(short)(hs2*(hs-xi)+.5);
  *iy=(short)(hs2*(hs-xn)+.5);
  if(*ix < 0 || *ix >510)return(0);
  if(*iy < 0 || *iy >510)return(0);
  return(1);
}

struct { int ra, dc; short mag, pr2, pd2; } u;
void cat_u3(int i360)
{
  double x1,x2, ra,dc,mas,xa,xd,xmag;
  short  ix,iy;
  char   f1[20];
  int    i,j,k,i87;

  mas=3600000.;    i=i360-1;
  x1=dn_a; x2=up_a;  if(x2<x1)x2+=24.;
  j=(int)(x1*10.); j--; if(j<0)k=0; else  k=u3index[j][i];
  i87=0; if(up_d>87. || dn_d<-87.){ i87=1;  k=0; }
  sprintf(f1,"u%03d\0",i360);
  strcpy(dis,disk);  strcat(dis,f1);
  fp=fopen(dis,"rb");
  if(fp==0)exit(0);
l05:
  fseek(fp,k*14,0);
l10:
  fread(&u,1,14,fp);   if(feof(fp))goto l20;
  k++;
  ra=u.ra/mas/15.;
  if(ra>x2 && i87==0)goto l100;               // normal exit
  if(ra<x1 && i87==0)goto l10;
  dc=(u.dc-mas*90.)/mas;  if(dc<dn_d || dc>up_d)goto l10;
  xmag=u.mag*.001;  if(xmag<0.)xmag=-xmag;  if(xmag > xlimag)goto l10;
  if(i_star(ra,dc,&ix,&iy)){
    if(epoch!=2000.0){
      astprs(ra,dc,2000.0,&xa,&xd,epoch);
      ra =xa+u.pr2*.1*(epoch-2000.0)/mas/15./cosdc;
      dc=xd+u.pd2*.1*(epoch-2000.0)/mas;
    }
    aa[n]=ra;
    dd[n]=dc;
    ee[n]=u.mag;
    no[n]=i360*1000000+k;
    ex[n]=ix;
    ey[n]=iy;
    n++; if(n==nn)n--;
  }
  goto l10;
l20:
  x1-=24.; x2-=24.;  k=0;
  if(i87==0)goto l05;
l100:
  fclose(fp);
}

void toms2(double aa,char *cc,int k)
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  cc[0]=32; if(a<0.){ a=-a; cc[0]='-'; }
  i=(int)a; b=(a-i)*60.;
  j=(int)b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&cc[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&cc[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(cc[7]==32)cc[7]='0';   if(cc[8]==32)cc[8]='0';
  if(cc[7]=='6'){
    cc[7]='0'; j++; sprintf(&cc[4],"%2.2d",j);
    if(cc[4]=='6'){
      cc[4]='0'; i++; sprintf(&cc[1],"%2.2d",i);
    }
    cc[3]=':'; cc[6]=':';
  }
}

void astjuy (double epoch,double *t)
{
  double jd;
  int year,centuy;
  year =(int)(epoch - 1);
  centuy = year / 100;
  jd =1721425.5+365.*year-centuy+ year/4 + centuy/4;
  year=(int)epoch;
  *t= jd + (epoch - year) * 365.25;
}

void astrox (double epoch, double p[3][3])
{
  double t,a,b,c,ca,cb,cc,sa,sb,sc,arc;
  arc=45./atan(1.);
  astjuy(epoch,&t);
  t = (t - 2451545.0) / 36525.;
  a = t * (0.6406161 + t * (0.0000839 + t * 0.0000050));
  b = t * (0.6406161 + t * (0.0003041 + t * 0.0000051));
  c = t * (0.5567530 - t * (0.0001185 + t * 0.0000116));
  ca = cos (a/arc);
  sa = sin (a/arc);
  cb = cos (b/arc);
  sb = sin (b/arc);
  cc = cos (c/arc);
  sc = sin (c/arc);
  p[0][0] = ca * cb * cc - sa * sb;
  p[1][0] = -sa * cb * cc - ca * sb;
  p[2][0] = -cb * sc;
  p[0][1] = ca * sb * cc + sa * cb;
  p[1][1] = -sa * sb * cc + ca * cb;
  p[2][1] = -sb * sc;
  p[0][2] = ca * sc;
  p[1][2] = -sa * sc;
  p[2][2] = cc;
}

void astprs(double ra1,double dc1,double ep1,double *ra2,double *dc2,double ep2)
{
  double r0[3],r1[3],p[3][3],arc;
  double r2,d2;

  arc=45./atan(1.);
  *ra2=ra1; *dc2=dc1;
  if(ep1 == ep2)return;
  r2 =ra1*15./arc; d2 =dc1/arc;
  r0[0]=cos(r2)*cos(d2); r0[1]=sin(r2)*cos(d2); r0[2]=sin(d2);
  if(ep1 != 2000.){
    astrox(ep1, p);
    r1[0] = p[0][0] * r0[0] + p[0][1] * r0[1] + p[0][2] * r0[2];
    r1[1] = p[1][0] * r0[0] + p[1][1] * r0[1] + p[1][2] * r0[2];
    r1[2] = p[2][0] * r0[0] + p[2][1] * r0[1] + p[2][2] * r0[2];
    r0[0] = r1[0]; r0[1] = r1[1]; r0[2] = r1[2];
  }
  if(ep2 != 2000.){
    astrox(ep2, p);
    r1[0] = p[0][0] * r0[0] + p[1][0] * r0[1] + p[2][0] * r0[2];
    r1[1] = p[0][1] * r0[0] + p[1][1] * r0[1] + p[2][1] * r0[2];
    r1[2] = p[0][2] * r0[0] + p[1][2] * r0[1] + p[2][2] * r0[2];
    r0[0] = r1[0];    r0[1] = r1[1];    r0[2] = r1[2];
  }
  *ra2  = atan2(r0[1], r0[0])/15.*arc;
  *dc2 = asin(r0[2])*arc;
  if(*ra2<0)*ra2+=24.;
}

void standc(double rc,double dc,double ra,double de,double *xi,double *xn)
{
  double sd,cd,td,co,tmp;
  sd=sin(dc);
  cd=cos(dc);
  td=tan(de);
  co=cos(ra-rc);
  tmp=sd*td+cd*co;
  *xi=sin(ra-rc)/tmp;
  *xn=(cd*td-sd*co)/tmp;
}

void astand(double rc,double dc,double xi,double xn,double *ra,double *de)
{
  double cd,td;
  cd=cos(dc);
  td=tan(dc);
  *ra=atan(xi/cd/(1.-xn*td));
  *de=atan((xn+td)*cos(*ra)/(1.-xn*td));
  *ra+=rc;
  cd=(*de)-dc; if(cd<0.)cd=-cd;
  if(cd>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
}

//    for gif
#define MAXCODES 4096
#define TABLESIZES 4999
unsigned char SuffixTable[4999], ByteBuf[2592], BlockBuf[256];
int Encode, RunBits, MaxCodeSize, ByteCount, ShiftBits;
int Code, Width, Height, Dots, Rows;
int PrefixCode, SuffixCode, RandomIndex, Val;
int EncodeTable[4999], PrefixTable[4999];
unsigned long TempCode;

void jClearTable()
{
  int i;
  Encode = 258;  RunBits = 9;  MaxCodeSize =512;
  for(i = 0; i < TABLESIZES; i++) EncodeTable[i] = 0;
}

void jFillBlockBuf()
{
  TempCode |= (unsigned long)Code << ShiftBits;
  ShiftBits += RunBits;
  while(ShiftBits >= 8)  {
    BlockBuf[++ByteCount] =(char)( TempCode & 0x00FF);
    if(ByteCount == 255){
      BlockBuf[0] = ByteCount;
      fwrite(BlockBuf, 1, ByteCount+1, fp0);
      ByteCount = 0;
    }
    TempCode >>= 8;
    ShiftBits -= 8;
  }
}

void togif()
{
  int i,k;
  short head1[7]={0x4947,0x3846,0x6137,0,0,0xf7,0};
  short head2[5]={0,0,0,0,0x800};
  fp0=fopen(f1,"wb");
  head1[3]=head2[2]=Width=lw2;
  head1[4]=head2[3]=Height=lh;
  fwrite(head1,1,13,fp0);
  for(i=0;i<16;i++)fwrite(&tcolor[i],1,3,fp0);
  for(i=16;i<256;i++)fwrite(&plate[i][0],1,3,fp0);
  fputc(0x2c,fp0);
  fwrite(head2,2,5,fp0);
  ByteCount = ShiftBits = TempCode = 0;
  jClearTable();
  Code = 256;
  jFillBlockBuf();

  for(Rows = 0; Rows <Height; Rows++)  {
    k=(Height-Rows-1)*lw;
    for(i=0;i<Width;i++)ByteBuf[i]=buf[k+i];         // difine in bm.bmBits
    if(Rows == 0) { PrefixCode = ByteBuf[0];  Dots = 1; }
    else Dots = 0;
    while( Dots < Width)  {
      SuffixCode = ByteBuf[Dots++];
      RandomIndex = PrefixCode ^ (SuffixCode << 4);
      if(RandomIndex == 0)  Val = 1;
      else Val = TABLESIZES - RandomIndex;
      while(1)  {
        if(EncodeTable[RandomIndex] == 0)  {
          Code = PrefixCode;
          jFillBlockBuf();
          if(Encode == MAXCODES)  {
            Code = 256;
            jFillBlockBuf();
            jClearTable();
          }
          else  {
            if(Encode == MaxCodeSize)  {
              MaxCodeSize <<= 1;
              RunBits++;
            }
            PrefixTable[RandomIndex] = PrefixCode;
            SuffixTable[RandomIndex] = SuffixCode;
            EncodeTable[RandomIndex] = Encode++;
          }
          PrefixCode = SuffixCode;
          break;
        }
        if(PrefixTable[RandomIndex] == PrefixCode &&
           SuffixTable[RandomIndex] == SuffixCode)  {
          PrefixCode = EncodeTable[RandomIndex];
          break;
        }
        else  {
          RandomIndex -= Val;
          if(RandomIndex < 0)  RandomIndex += TABLESIZES;
        }
      }
    }
  }
  Code = PrefixCode;
  jFillBlockBuf();
  Code = 257;
  jFillBlockBuf();
  if(ShiftBits > 0 || ByteCount > 0)   {
    BlockBuf[++ByteCount] =(char)( TempCode & 0x00FF);
    BlockBuf[0] = ByteCount;
    fwrite(BlockBuf, 1, ByteCount+1, fp0);
    ByteCount = 0;
  }
  fputc(0, fp0);  fputc(';', fp0);
  fclose(fp0);
}
